/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point_$type, runOn, typeCast, markType, markDep } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
var HorizontalRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.ng = function () {
        _super.prototype.ng.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.ah = function (a) {
        var b = this.aj(this.vl(), this.vm.f, this.wn(this.cj), this.wo(this.cj), this.tm(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ai = function (a) {
        var b = this.aj(this.vl(), this.vm.f, this.wn(this.cj), this.wo(this.cj), this.tm(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_e7 = function () {
        return true;
    };
    HorizontalRangeCategorySeries.prototype.bx = function () {
        if (this.by == 0) {
            return 1;
        }
        else {
            return _super.prototype.bx.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj));
    };
    HorizontalRangeCategorySeries.prototype.jd = function (a, b) {
        return this.je(a, b, this.xAxis, runOn(this, this.wl), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.jf = function (a, b) {
        return this.jg(a, b, this.xAxis, runOn(this, this.wl), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.ht = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.lf;
        return this.hu(a, b, this.xAxis, d, e, f, runOn(this, this.wl));
    };
    HorizontalRangeCategorySeries.prototype.h9 = function (a, b, c) {
        if (this.cy == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cj);
        var e = new ScalerParams(0, this.cy.tn, this.cj.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.cy.tn, this.cj.bx, d);
        return this.ib(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.wl), b, c);
    };
    HorizontalRangeCategorySeries.prototype.h7 = function (a, b, c) {
        if (this.cy == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cj);
        var e = new ScalerParams(0, this.cy.tn, this.cj.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.cy.tn, this.cj.bx, d);
        return this.ib(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.wl), b, c);
    };
    HorizontalRangeCategorySeries.prototype.h5 = function (a, b, c) {
        if (this.cy == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cj);
        var e = new ScalerParams(0, this.cy.tn, this.cj.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.cy.tn, this.cj.bx, d);
        return this.ib(this.highColumn, a, this.xAxis, e, f, runOn(this, this.wl), b, c);
    };
    HorizontalRangeCategorySeries.prototype.td = function (a, b, c) {
        var _this = this;
        return this.tj(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj)), this.yAxis, this.xAxis, runOn(this, this.h5), function (d, e) { return _this.jg(d, e, _this.xAxis, runOn(_this, _this.wl), _this.highColumn); }, function (d, e) { return _this.je(d, e, _this.xAxis, runOn(_this, _this.wl), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.tf = function (a, b, c) {
        var _this = this;
        return this.tj(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj)), this.yAxis, this.xAxis, runOn(this, this.h7), function (d, e) { return _this.jg(d, e, _this.xAxis, runOn(_this, _this.wl), _this.lowColumn); }, function (d, e) { return _this.je(d, e, _this.xAxis, runOn(_this, _this.wl), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.th = function (a, b, c) {
        return this.tj(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.wh = function () {
        return this.yAxis != null && this.yAxis.c1();
    };
    HorizontalRangeCategorySeries.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[4]:
                this.np(typeCast(Axis.$, c));
                this.pf(typeCast(Axis.$, d));
                this.vv.cu.g(this.hj);
                this.pp(false);
                this.ol();
                break;
            case HorizontalRangeCategorySeries.$$p[5]:
                this.np(typeCast(Axis.$, c));
                this.pf(typeCast(Axis.$, d));
                this.vv.cu.g(this.hj);
                this.wh();
                this.pp(false);
                this.ol();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.x3 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.x2 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.h7(c, false, false);
        var e = this.h5(c, false, false);
        var f = new DataLegendSeriesValueInfo();
        f.a = 1;
        f.l = e > d ? d : e;
        f.p = "Low";
        f.q = this.xr != null ? this.xr : "Low";
        f.r = this.x8 != null ? this.x8 : "L:";
        f.s = this.ya != null ? this.ya : "";
        var g = new DataLegendSeriesValueInfo();
        g.a = 2;
        g.l = e > d ? e : d;
        g.p = "High";
        g.q = this.xo != null ? this.xo : "High";
        g.r = this.x4 != null ? this.x4 : "H:";
        g.s = this.x6 != null ? this.x6 : "";
        var h = new DataLegendSeriesValueInfo();
        h.a = 7;
        h.l = Math.abs(g.l - f.l);
        h.p = "Range";
        h.q = "Range";
        h.r = "R:";
        h.k = true;
        var i = new DataLegendSeriesValueInfo();
        i.a = 6;
        i.l = f.l + (h.l / 2);
        i.p = "Average";
        i.q = "Average";
        i.r = "A:";
        i.k = true;
        var j = new DataLegendSeriesContext();
        j.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(f);
            $ret.add(h);
            $ret.add(i);
            return $ret;
        })());
        j.b = this.aw();
        return j;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.wi;
        },
        enumerable: false,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['HighMemberAsLegendLabel:x4:ye', [2, null], 'HighMemberAsLegendUnit:x6:yf', [2, null], 'LowMemberAsLegendLabel:x8:yg', [2, null], 'LowMemberAsLegendUnit:ya:yh', [2, null], 'XAxis::yi', [CategoryAxisBase.$, null], 'YAxis::yj', [NumericYAxis.$, null]]);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));
export { HorizontalRangeCategorySeries };
